//-------------------------------------------------------------------------------------
// File : SampleRenderer.h
// Desc : Sample of Renderer implementation
// Copyright(c) Project Asura. All right reserved.
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
// History
//-------------------------------------------------------------------------------------
// <---> 2011/08/09 [Pocol] VK쐬
// <End>

#ifndef __SAMPLE_RENDERER_H__
#define __SAMPLE_RENDERER_H__

//-------------------------------------------------------------------------------------
// Includes
//-------------------------------------------------------------------------------------
#include "asdxDemoApp.h"
#include "asdxModelUtil.h"
#include "asdxShaderUtil.h"


//------------------------------------------------------------------------------------
// Defines
//------------------------------------------------------------------------------------
#ifndef AS_ALIGN16
#define AS_ALIGN16 __declspec( align( 16 ) )
#endif


namespace Asura {
namespace SampleProgram {

/////////////////////////////////////////////////////////////////////////
// SampleRenderer class
/////////////////////////////////////////////////////////////////////////
class SampleRenderer : public IRenderer
{
	//-------------------------------------------------------------------
	// list of friend classes and methods
	//-------------------------------------------------------------------
	/* NOTHING */

private:
	//-------------------------------------------------------------------
	// private variables
	//-------------------------------------------------------------------
	Asura::Util::ModelData    mSaturn;		//!< ǂ
	Asura::Util::ModelData    mGround;		//!< n
	D3DXMATRIX				  mWorld;		//!< [hs
	D3DXMATRIX				  mView;		//!< r[s
	D3DXMATRIX				  mProjection;	//!< ˉes
	D3DXVECTOR3				  mViewDir;		//!< xNg
	D3DXVECTOR3				  mLightDir;	//!< Cg̕xNgi̓CgɌj
    D3DXVECTOR3               mLightAmbient;
    D3DXVECTOR3               mLightDiffuse;
	D3DXVECTOR3				  mLightSpecular;
    ID3D11Buffer*             mpLightColorBuffer;  //!< xNgobt@ւ̃|C^
    Asura::Graphics::ShaderContainer mShaders; //!< VF[_

	//-------------------------------------------------------------------
	// private methods
	//-------------------------------------------------------------------
	void SetLightColor( 
        ID3D11DeviceContext* pImmediateContext,
        const D3DXVECTOR3 &lightAmbient,
        const D3DXVECTOR3 &lightDiffuse,
		const D3DXVECTOR3 &lightSpecular );

protected:
	//-------------------------------------------------------------------
	// protected variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// protected methods
	//-------------------------------------------------------------------
	/* NOTHING */

public:
	//-------------------------------------------------------------------
	// public variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// public methods
	//-------------------------------------------------------------------
    SampleRenderer();
    virtual ~SampleRenderer();
    bool	OnInit();
    void	OnRelease();
    bool	OnCreateDevice( ID3D11Device* pDevice, const DXGI_SURFACE_DESC* pDesc );
    void	OnDestroyDevice();
	bool    OnResizeSwapChain( ID3D11Device* pDevice, IDXGISwapChain* pSwapChain, const DXGI_SURFACE_DESC *pDesc );
    void	OnUpdate( double time, float elapsedTime );
    void	OnRender( ID3D11Device* pDevice, ID3D11DeviceContext* pImmediateContext, double time, float elapsedTime );
    char*	GetTag() { return "SampleRenderer"; }
};


} // namespace SampleProgram
} // namespace Asura



#endif//__MODEL_RENDERER_H__